Bespoke script for calculating and plotting some series solutions
of the functional equation f'( f( x ) ) = x.

Idea: suppose f has fixed point p,
apply the chain rule to functional equation
get values of f's derivatives at p
get truncated taylor series expansion of f at p,
plot series to get some idea about values, convergence.

We use Faa Di Bruno's formula for iterated derivatives, in terms of Bell numbers.
We also plot the "ansatz" solution, i.e. the solution of the form x -> a * x ^ b where a and b are positive.

Uses LOVE as a dependency for its plotting: https://love2d.org
Solution is plotted in red, first derivative is plotted in green.

Keys:
Q - Increase p
E - Decrease p
WASD - Translate view
Z - Zoom in
C - Zoom out
F - Increase order of series expansion
R - Decrease order
